# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from . import _utilities, _tables
from . import outputs
from ._inputs import *

__all__ = ['ContentLibrary']


class ContentLibrary(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 publication: Optional[pulumi.Input[pulumi.InputType['ContentLibraryPublicationArgs']]] = None,
                 storage_backings: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 subscription: Optional[pulumi.Input[pulumi.InputType['ContentLibrarySubscriptionArgs']]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        Create a ContentLibrary resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: A description of the Content Library.
        :param pulumi.Input[str] name: The name of the Content Library.
        :param pulumi.Input[pulumi.InputType['ContentLibraryPublicationArgs']] publication: Options to publish a local Content Library.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] storage_backings: The managed object reference ID on which to store Content Library
               items.
        :param pulumi.Input[pulumi.InputType['ContentLibrarySubscriptionArgs']] subscription: Options to publish a local Content Library.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['description'] = description
            __props__['name'] = name
            __props__['publication'] = publication
            if storage_backings is None:
                raise TypeError("Missing required property 'storage_backings'")
            __props__['storage_backings'] = storage_backings
            __props__['subscription'] = subscription
        super(ContentLibrary, __self__).__init__(
            'vsphere:index/contentLibrary:ContentLibrary',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            description: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            publication: Optional[pulumi.Input[pulumi.InputType['ContentLibraryPublicationArgs']]] = None,
            storage_backings: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            subscription: Optional[pulumi.Input[pulumi.InputType['ContentLibrarySubscriptionArgs']]] = None) -> 'ContentLibrary':
        """
        Get an existing ContentLibrary resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: A description of the Content Library.
        :param pulumi.Input[str] name: The name of the Content Library.
        :param pulumi.Input[pulumi.InputType['ContentLibraryPublicationArgs']] publication: Options to publish a local Content Library.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] storage_backings: The managed object reference ID on which to store Content Library
               items.
        :param pulumi.Input[pulumi.InputType['ContentLibrarySubscriptionArgs']] subscription: Options to publish a local Content Library.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["description"] = description
        __props__["name"] = name
        __props__["publication"] = publication
        __props__["storage_backings"] = storage_backings
        __props__["subscription"] = subscription
        return ContentLibrary(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        A description of the Content Library.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the Content Library.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def publication(self) -> pulumi.Output['outputs.ContentLibraryPublication']:
        """
        Options to publish a local Content Library.
        """
        return pulumi.get(self, "publication")

    @property
    @pulumi.getter(name="storageBackings")
    def storage_backings(self) -> pulumi.Output[Sequence[str]]:
        """
        The managed object reference ID on which to store Content Library
        items.
        """
        return pulumi.get(self, "storage_backings")

    @property
    @pulumi.getter
    def subscription(self) -> pulumi.Output[Optional['outputs.ContentLibrarySubscription']]:
        """
        Options to publish a local Content Library.
        """
        return pulumi.get(self, "subscription")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

